function getVideo(doc) {
	return Array.from(doc.getElementsByTagName('video')).map(video => ({
		src: video.src
	}))
}

function getImgs(doc) {
	return Array.from(doc.getElementsByTagName('img'))
		.map(img => ({
			src: img.currentSrc, // 用 img.src 如果要本来的 src
			width: img.naturalWidth,
			height: img.naturalHeight
		}))
}
window.onload = function () {
       init();
}
function createButton() {
	let btn = document.createElement('div');
	btn.style.width = '50px';
	btn.style.height = '50px';
	btn.className = 'cur-btn';
	btn.style.backgroundColor = '#0095f6';
	btn.style.position = 'absolute';
	btn.style.bottom = '20px';
	btn.style.right = '20px';
	btn.style.textAlign = 'center';
	btn.style.lineHeight = '50px';
	btn.style.fontSize = '14px';
	btn.style.color = '#fff';
	btn.innerText = '下载';
	btn.style.borderRadius = '50%';
	return btn;
}
// window.addEventListener('scroll', init);
function init() {
	let list = document.getElementsByClassName('RzuR0');
	let oneVideo = document.getElementsByClassName('Btbrr');
	let oneImg = document.getElementsByClassName('eLAPa');
	let dom = document.getElementById('react-root');
	if (list.length) {
		for (var i = 0; i < list.length; i++) {
			let hasBtn = false;
			list[i].childNodes.forEach(it => {
				if (it.className && it.className.indexOf('cur-btn') != -1) {
					hasBtn = true;
					return
				}
			})
			if (hasBtn) {
				continue;
			}
			list[i].style.position = 'relative';
			let button = createButton();
			list[i].appendChild(button);
			list[i].addEventListener('click', function(e) {
				if (e.target.className === 'cur-btn' ||
					e.target.parentNode.nodeName === 'ARTICLE') {
					console.log(getImgs(this), getVideo(this))
					let imgs = getImgs(this) || [];
					let videos = getVideo(this) || [];
					try {
					    console.log("setJsMediaBuild --> type " + videos.length ? 1 : 0 +",poster is "+imgs[0].src +",src "
					    + videos.length ? videos[0].src : imgs[0].src
					    +",width " +  imgs[0].wdith +",height " + imgs[0].height)
						window.SniffWebViewJs.setJsMediaBuild(videos.length ? 1 : 0, imgs[0].src, videos.length ?
							videos[0].src : imgs[0].src, imgs[0].wdith, imgs[0].height)
					} catch (e) {
						//TODO handle the exception
						console.log(e)
					}
					console.log('ok！')
				}
			})
		}
	}
	if (oneVideo.length) {
		for (var i = 0; i < oneVideo.length; i++) {
			let hasBtn = false;
			oneVideo[i].childNodes.forEach(it => {
				if (it.className && it.className.indexOf('cur-btn') != -1) {
					hasBtn = true;
					return
				}
			})
			if (hasBtn) {
				continue;
			}
			oneVideo[i].style.position = 'relative';
			let button = createButton();
			oneVideo[i].appendChild(button);
			oneVideo[i].addEventListener('click', function(e) {
				if (e.target.className === 'cur-btn' ||
					e.target.parentNode.nodeName === 'ARTICLE') {
					console.log(getImgs(this), getVideo(this))
					let imgs = getImgs(this) || [];
					let videos = getVideo(this) || [];
					try {
						window.SniffWebViewJs.setJsMediaBuild(1, imgs[0].src, videos[0].src, imgs[0].wdith, imgs[0].height)
					} catch (e) {
						//TODO handle the exception
						console.log(e)
					}
					console.log('ok！')
				}
			})
		}
	}
	if (oneImg.length) {
		for (var i = 0; i < oneImg.length; i++) {
			let hasBtn = false;
			oneImg[i].childNodes.forEach(it => {
				if (it.className && it.className.indexOf('cur-btn') != -1) {
					hasBtn = true;
					return
				}
			})
			if (hasBtn) {
				continue;
			}
			oneImg[i].style.position = 'relative';
			let button = createButton();
			oneImg[i].appendChild(button);
			oneImg[i].addEventListener('click', function(e) {
				if (e.target.className === 'cur-btn' ||
					e.target.parentNode.nodeName === 'ARTICLE') {
					console.log(getImgs(this));
					let imgs = getImgs(this) || [];
					try {
						window.SniffWebViewJs.setJsMediaBuild(0, imgs[0].src, imgs[0].src, imgs[0].wdith, imgs[0]
							.height)
					} catch (e) {
						//TODO handle the exception
						console.log(e)
					}
					console.log('ok！')
				}
			})
		}
	}

}


let box = document.querySelector('body') // 监听对象
let startTime = '' // 触摸开始时间
let startDistanceX = '' // 触摸开始X轴位置
let startDistanceY = '' // 触摸开始Y轴位置
let endTime = '' // 触摸结束时间
let endDistanceX = '' // 触摸结束X轴位置
let endDistanceY = '' // 触摸结束Y轴位置
let moveTime = '' // 触摸时间
let moveDistanceX = '' // 触摸移动X轴距离
let moveDistanceY = '' // 触摸移动Y轴距离
box.addEventListener("touchstart", (e) => {
	startTime = new Date().getTime()
	startDistanceX = e.touches[0].screenX
	startDistanceY = e.touches[0].screenY
})
box.addEventListener("touchend", (e) => {
	endTime = new Date().getTime()
	endDistanceX = e.changedTouches[0].screenX
	endDistanceY = e.changedTouches[0].screenY
	moveTime = endTime - startTime
	moveDistanceX = startDistanceX - endDistanceX
	moveDistanceY = startDistanceY - endDistanceY
	// console.log(moveDistanceX, moveDistanceY)
	// 判断滑动距离超过40 且 时间小于500毫秒
	if ((Math.abs(moveDistanceX) > 40 || Math.abs(moveDistanceY) > 40) && moveTime < 500) {
		// 判断X轴移动的距离是否大于Y轴移动的距离
		if (Math.abs(moveDistanceX) > Math.abs(moveDistanceY)) {
			// 左右
			init()
			console.log(moveDistanceX > 0 ? '左' : '右')
		} else {
			// 上下
			init()
			console.log(moveDistanceY > 0 ? '上' : '下')
		}
	}
})
